// C source for perlc v.2.0
// Compile Perl script to statically linked relocatable executable and
// copy its modules in a relative-path 'lib' folder.
// Authors:
// David Ljung Madison <marginalhacks.com/Hacks/perlc/>
// Dimitar D. Mitov <github.com/ddmitov>
// License: http://MarginalHacks.com/License/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "aes256.h"

void dump(uint8_t *buffer, size_t size);

int main (int argc, char *argv[])
{
  if (argv[1] && argv[2]) {
    FILE *file = fopen(argv[1], "rb");
    fseek(file, 0, SEEK_END);
    long fsize = ftell(file);
    fseek(file, 0, SEEK_SET);

    char *file_contents = malloc(fsize + 1);
    fread(file_contents, fsize, 1, file);

    fclose(file);

    char mac[18];
    char password[36];

    if (strcmp("current", argv[2]) == 0) {
      FILE *get_first_mac_process;

      char *get_first_mac_command =
        "cat /sys/class/net/$(ls /sys/class/net | head -n 1)/address";

      if ((get_first_mac_process = popen(get_first_mac_command, "r")) == NULL) {
        printf("Error starting 'cat'!\n");
        return -1;
      }

      fgets(mac, 18, get_first_mac_process);

      strcpy(password, mac);
      strcat(password, "::");
      strcat(password, mac);

      if (pclose(get_first_mac_process)) {
        printf("'cat' command was not found or exited with error!\n");
        return -1;
      }
    }

    if (strcmp("current", argv[2]) != 0) {
      sscanf(argv[2], "%s", mac);
    }

    rfc3686_blk ctr = {
      {0x00, 0x1C, 0xC5, 0xB7}, /* nonce */
      {0x51, 0xA5, 0x1D, 0x70, 0xA1, 0xC1, 0x11, 0x48}, /* IV */
      {0x00, 0x00, 0x00, 0x01} /* counter */
    };

    aes256_context ctx;

    uint8_t *encryption_buffer = (uint8_t *)(file_contents);
    size_t buffer_length = strlen(file_contents);

    aes256_init(&ctx, (uint8_t *)(password));
    aes256_setCtrBlk(&ctx, &ctr);
    aes256_encrypt_ctr(&ctx, encryption_buffer, buffer_length);
    aes256_done(&ctx);

    dump(encryption_buffer, buffer_length);
  }
}

void dump(uint8_t *buffer, size_t size)
{
  size_t index;
  for (index = 0; index < size; index++) {
    printf("0x%02x%s", buffer[index],
      ((index % 16 == 15) && (index < size - 1)) ? ",\n" : ", ");
  }
}
